Subject: File Repository does not work with Workspaces

Description

The FileRepository \TYPO3\CMS\Core\Resource\FileRepository does not support versioning/workspaces. The bug is in the function
"findByRelation".

The patch in attachment work for me.

Related issues:

related to Core - Task # 59276: Integrate functional DataHandler tests for FAL Resolved 2014-06-02
related to Core - Bug # 48464: Images in workspaces don't work New 2013-05-22
duplicated by Core - Task # 58305: Severe Issues with FAL records when in wor... Resolved 2014-04-29
duplicated by Core - Task # 54956: Invalid workspace image preview in page an... Closed 2014-01-13

Associated revisions

Revision ed5b0d12 - 2014-06-11 11:50 - Benjamin Mack

[BUGFIX] File Relations don't work with workspaces

The file repository used to resolve all sys_file_references
handles enable fields manually currently, which is bad because

it forgets to handle the workspace-related where clause.

The attached patch splits the behavior into frontend and

backend context. In backend the RelationHandler is capable
of automatically resolving IRRE structures. In frontend mode
the enableFiels and version preview settings are relevant to

show correct results.

Resolves: #43916

Releases: 6.2

Change-Id: 16¢19e5d7b4cd7a2134921c669b82ab90b54844de
Reviewed-on: https://review.typo3.org/29712
https://review.typo3.org/29712

History

#1 - 2013-03-07 11:08 - Reindl Bernd

Hello,

i have the same problem with TYPO3 6.0.3.

With this patch the relations for the workspace are found.

But if i create a relation in the workspace, the relation is lost. So i have extend the function.
@
public function findByRelation($tableName, $fieldName, $uid) {
SitemList = array();
if (N\TYPO3\CMS\Core\Utility\MathUTtility::canBelnterpretedAsInteger($uid)) {
throw new \InvalidArgumentException('Uid of related record has to be an integer.', 1316789798);
}
$considerWorkspaces = lempty($GLOBALS['BE_USER']->workspace) &&
\TYPO3\CMS\Backend\Utility\BackendUltility::isTableWorkspaceEnabled($tableName) ? 1 : 0;

if($considerWorkspaces)

$row = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows(

%
s

$tableName,
'uid=". intval($uid)
);
$row = $row[0];
\TYPO3\CMS\Backend\Utility\BackendUtility::workspaceOL ($tableName, $row);
if(isset($row[_ORIG_uid1))
$uid = $row['_ORIG_uid];
}
$references = $GLOBALS['TYPO3_DB'->exec_SELECTgetRows(

1%t
)

'sys_file_reference',
'tablenames=". $GLOBALS['TYPO3_DB']->fullQuoteStr($tableName, 'sys_file_reference’) .
" AND deleted = 0'.
" AND hidden =0'.
" AND uid_foreign=". intval($uid) .
' AND fieldname=". $GLOBALS['TYPO3_DB'->fullQuoteStr($fieldName, 'sys_file_reference’),

'sorting_foreign'

);

foreach ($references as $referenceRecord) {
if($referenceRecord['t3ver_state'] > 0)

continue;

}

if ($considerWorkspaces)

\TYPO3\CMS\Backend\Utility\BackendUtility::workspaceOL('sys_file_reference', $referenceRecord);
}

SitemList[] = $this->createFileReferenceObject($referenceRecord);

}

return $itemList;
@

This works fine for me.

#2 - 2013-03-27 10:06 - Marius S.

Reindl Bernd's version works great for me! Thank you.

Please have this one released.

#3 - 2013-10-30 01:02 - Gabe Blair
@Reindl: Thanks for the patch. Will you be submitting a Gerrit change for it? You will have a much better chance of getting it into the official core that

way.

#4 - 2014-01-20 13:42 - Alexander Opitz

- Project changed from File Abstraction Layer to Core

- Category changed from Frontend to Frontend

#5 - 2014-01-20 13:42 - Alexander Opitz

- Category changed from Frontend to File Abstraction Layer (FAL)

- Is Regression set to No

- TYPO3 Version set to 6.0

#6 - 2014-04-25 17:38 - Alex Poll

Dear TYOPS3 core team,

we're using TYPO3 6.1.7 and have experienced this problem. (Images of not yet published content don't show up in Preview).

Although we've implemented the above patch it's still not working.

I'd appreciate if you could help!

Are you going to fix this bug for TYPO3 6.1.7?

And is the same bug present in the new TYPO3 6.2 LTS Version?

Kind regards,

Alex

#7 - 2014-04-25 17:52 - Markus Timtner

Hi Alex,

this issue has forced me to do the update to v6.2LTS - and | am not looking back since ;)

The FAL implementation is now fully Workspace compatible, along with other significant Ul improvements.
Kind regards,

MT

#8 - 2014-04-25 17:59 - Alex Poll

Thanks a lot Markus for your fast response. Sounds good!

#9 - 2014-04-28 15:25 - Benjamin Mack

Hey,

well, files might work, but file relations won't work with repositories at all anymore.

Change an image relation to tt_content (sys_file_reference) in a workspace and publish that - the live workspace will show two records.

#10 - 2014-04-28 15:29 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/29712

#11 - 2014-04-28 16:08 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/29712

#12 - 2014-05-14 10:55 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/29712

#13 - 2014-05-14 10:55 - Gerrit Code Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/30100

#14 - 2014-05-14 11:49 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/29712

#15 - 2014-06-05 17:36 - Gerrit Code Review
Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.0rg/29712

#16 - 2014-06-05 21:35 - Oliver Hader
- Parent task set to #58284

#17 - 2014-06-10 11:41 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/29712

#18 - 2014-06-10 15:44 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.0rg/29712

#19 - 2014-06-10 17:40 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/29712

#20 - 2014-06-11 12:30 - Benjamin Mack
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:ed5b0d124dcc7b8975e37b9afda6fae18c8aff6e.

#21 - 2014-06-12 13:40 - Oliver Hader

- Assigned To set to Benjamin Mack

#22 - 2014-07-10 16:40 - Alex Péll

- File Screen_Shot _2014-07-10_at 16.31.46.png added

- File Screen_Shot_2014-07-10_at_16.35.28.png added

- File Screen_Shot_2014-07-10_at_16.34.39.png added

- File Screen_Shot_2014-07-10_at_16.38.40.png added

Dear TYOPS3 core team,

we've recently updated (from 6.1.7) to TYPO3 6.2.3 in order to have this problem solved. Unfortunately a new problem come up:

Images of not yet published content (workspaces mode) now appear twice in the backend layout of the page and in the website preview. Please have a

look at the attached screenshots.

Thanks for your support,
Alex

2015-08-04 5/6


https://review.typo3.org/29712
https://review.typo3.org/29712
https://review.typo3.org/29712
https://review.typo3.org/29712

#23 - 2014-07-15 17:50 - Gerhard Rupp

It seems that this is fixed in TYPOS 6.2.4.

Files

FileRepositoryWorkspace.diff

Screen_Shot_2014-07-10_at_16.31.46.png
Screen_Shot_2014-07-10_at_16.35.28.png
Screen_Shot_2014-07-10_at_16.34.39.png
Screen_Shot_2014-07-10_at_16.38.40.png

2015-08-04

1.5kB
82.8 kB
25 kB
21.4kB
43.6 kB

2012-12-12
2014-07-10
2014-07-10
2014-07-10
2014-07-10

Devid Messner
Alex Pl
Alex Paoll
Alex Poll
Alex Poll

6/6



